# class ActiveSupport::Duration

Provides accurate date and time measurements using Date#advance and Time#advance, respectively. It mainly supports the methods on Numeric. Example:

    1.month.ago       # equivalent to Time.now.advance(:months => -1)

### Attributes

parts[RW]
value[RW]

### Public Instance Methods

+(other) click to toggle source

Adds another Duration or a Numeric to this Duration. Numeric values are treated as seconds.

    # File lib/active_support/duration.rb, line 21
    def +(other)
      if Duration === other
        Duration.new(value + other.value, @parts + other.parts)
      else
        Duration.new(value + other, @parts + [[:seconds, other]])
      end
    end

-(other) click to toggle source

Subtracts another Duration or a Numeric from this Duration. Numeric values are treated as seconds.

    # File lib/active_support/duration.rb, line 31
    def -(other)
      self + (-other)
    end

==(other) click to toggle source

Returns true if `other` is also a Duration instance with the same `value`, or if `other == value`.

    # File lib/active_support/duration.rb, line 46
    def ==(other)
      if Duration === other
        other.value == value
      else
        other == value
      end
    end

ago(time = ::Time.current) click to toggle source

Calculates a new Time or Date that is as far in the past as this Duration represents.

    # File lib/active_support/duration.rb, line 69
    def ago(time = ::Time.current)
      sum(-1, time)
    end

Also aliased as: until
from_now(time = ::Time.current) click to toggle source
Alias for: since
since(time = ::Time.current) click to toggle source

Calculates a new Time or Date that is as far in the future as this Duration represents.

    # File lib/active_support/duration.rb, line 62
    def since(time = ::Time.current)
      sum(1, time)
    end

Also aliased as: from_now
until(time = ::Time.current) click to toggle source
Alias for: ago